/**
 * Copyright (c) 2025 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#include "term.h"
#include "util/memory.h"
#include <sys/ioctl.h>

term_t TERM;

void termInit() {
  memoryZero(&TERM, sizeof(term_t));

  struct winsize w;
  if(ioctl(STDOUT_FILENO, TIOCGWINSZ, &w) == 0) {
    TERM.width = w.ws_col;
    TERM.height = w.ws_row;
  }
}

void termUpdate() {
  struct winsize w;
  if(ioctl(STDOUT_FILENO, TIOCGWINSZ, &w) == 0) {
    TERM.width = w.ws_col;
    TERM.height = w.ws_row;
  }
}

void termClear() {
  printf("\033[2J\033[H");
}

void termPushChar(const char_t c) {
  putchar(c);
}

void termFlush() {
  fflush(stdout);
}