/**
 * Copyright (c) 2025 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#pragma once
#include "dusk.h"

typedef struct {
  int32_t width;
  int32_t height;
} term_t;

extern term_t TERM;

/**
 * Initialize the terminal system.
 */
void termInit();

/**
 * Update the terminal system, typically called each frame.
 */
void termUpdate();

/**
 * Clear the terminal screen and reset cursor position.
 */
void termClear();

/**
 * Push a character to the terminal output buffer.
 * 
 * @param c The character to push.
 */
void termPushChar(const char_t c);

/**
 * Flush the terminal output buffer to the terminal.
 */
void termFlush();